<?php

namespace App\Community\Controllers;

use App\Http\Controllers\Controller;
use App\Models\Order;
use App\Models\SchedulePeriod;
use Encore\Admin\Controllers\Dashboard;
use Encore\Admin\Layout\Column;
use Encore\Admin\Layout\Content;
use Encore\Admin\Layout\Row;
use Encore\Admin\Widgets\InfoBox;

class HomeController extends Controller
{
    public function index(){
        return redirect('/cdms/home');
    }
    public function home(Content $content)
    {
        return $content
            ->title('数据概况')
            ->description('社区段实时数据')
            ->row($this->real_data())
            ->row($this->vaccine_data())
            ->row($this->nurse_data())
            ->row($this->schedule_data());
    }

    public function real_data()
    {
        $data = StatController::service();
        return view('cdms.real_data',compact('data'));
    }

    public function vaccine_data()
    {
        $data = StatController::vaccine();
        return view('cdms.vaccine_data',compact('data'));
    }

    public function nurse_data()
    {
        $data = StatController::nurse();
        return view('cdms.nurse_data',compact('data'));
    }

    public function schedule_data()
    {
        $data = StatController::schedule();
        return view('cdms.schedule_data',compact('data'));
    }

    public function order_detail()
    {
        $id = request('id');
        if(empty($id)){
            return redirect('/cdms/docter_chats');
        }
        $data = Order::where('id',$id)->with('orderPatient')->first();
        $content = new Content();
        $status = Order::getStatus();
        $content->view('cdms.order_detail',compact('data','status'));

        return $content;
    }
}
